<p align="center">
  <img src="https://github.com/vesoft-inc/nebula/raw/master/docs/logo.png"/>
  <br> English | <a href="README-CN.md">中文</a>
  <br>A distributed, scalable, lightning-fast graph database<br>
</p>
<p align="center">
  <a href="https://github.com/vesoft-inc/nebula-graph/actions?workflow=docker">
    <img src="https://github.com/vesoft-inc/nebula-graph/workflows/docker/badge.svg" alt="build docker image workflow"/>
  </a>
  <a href="http://githubbadges.com/star.svg?user=vesoft-inc&repo=nebula&style=default">
    <img src="http://githubbadges.com/star.svg?user=vesoft-inc&repo=nebula&style=default" alt="nebula star"/>
  </a>
  <a href="http://githubbadges.com/fork.svg?user=vesoft-inc&repo=nebula&style=default">
    <img src="http://githubbadges.com/fork.svg?user=vesoft-inc&repo=nebula&style=default" alt="nebula fork"/>
  </a>
  <br>
</p>

# What is Nebula Graph?

**WARNING**
This is the Nebula Graph 2.0 pre-release. Use it only if you need to test the latest features or performance improvements. DO NOT use it in production.

**Nebula Graph** is an open-source graph database capable of hosting super large scale graphs with dozens of billions of vertices (nodes) and trillions of edges, with milliseconds of latency.

Compared with other graph database solutions, **Nebula Graph** has the following advantages:

* Symmetrically distributed
* Storage and computing separation
* Horizontal scalability
* Strong data consistency by RAFT protocol
* SQL-like query language
* Role-based access control for higher level security

## Notice of Release

The Nebula Graph team is glad to announce the Nebula Graph 2.0 pre-release. This is a brand new start with several important updates, and more of them are on the way. Welcome to join us.
To use the stable release, see [Nebula Graph 1.0](https://github.com/vesoft-inc/nebula).

## Roadmap

See our [Roadmap](https://github.com/vesoft-inc/nebula/wiki/Nebula-Graph-Roadmap-2020) for what's coming soon in **Nebula Graph**.

## Quick start

Read the [Getting started](https://docs.nebula-graph.io/manual-EN/1.overview/2.quick-start/1.get-started/) article for a quick start.

Please note that you need to install **Nebula Graph**, either by [installing source code](https://docs.nebula-graph.io/manual-EN/3.build-develop-and-administration/1.build/1.build-source-code/) or by [docker compose](https://docs.nebula-graph.io/manual-EN/3.build-develop-and-administration/1.build/2.build-by-docker/), before you can actually start using it. If you prefer a video tutorial, visit our [YouTube channel](https://www.youtube.com/channel/UC73V8q795eSEMxDX4Pvdwmw/videos).

## Getting help
In case you encounter any problems playing around **Nebula Graph**, please reach out for help:
* [Slack channel](https://nebulagraph.slack.com/archives/DJQC9P0H5/p1557815158000200)
* [Stack Overflow](https://stackoverflow.com/questions/tagged/nebulagraph)

## Documentation

* [简体中文](https://docs.nebula-graph.com.cn/)
* [English](https://docs.nebula-graph.io/)

## Architecture
![image](https://github.com/vesoft-inc/nebula-docs/raw/master/images/Nebula%20Arch.png)

## Contributing

Contributions are warmly welcomed and greatly appreciated. And here are a few ways you can contribute:

* Start by some [good first issues](https://github.com/vesoft-inc/nebula/issues?q=is%3Aissue+is%3Aopen+label%3A%22good+first+issue%22)
* Submit Pull Requests to us. See [how-to-contribute](https://docs.nebula-graph.io/manual-EN/4.contributions/how-to-contribute/).

## Licensing

**Nebula Graph** is under [Apache 2.0](https://www.apache.org/licenses/LICENSE-2.0) license, so you can freely download, modify, and deploy the source code to meet your needs. You can also freely deploy **Nebula Graph** as a back-end service to support your SaaS deployment.

In order to prevent cloud providers monetizing from the project without contributing back, we added [Commons Clause 1.0](https://commonsclause.com/) to the project. As mentioned above, we fully commit to the open source community. We would love to hear your thoughts on the licensing model and are willing to make it more suitable for the community.

## Contact

* Twitter: <a href="https://twitter.com/NebulaGraph">@NebulaGraph</a>
* <a href="https://www.linkedin.com/company/vesoft-nebula-graph/">LinkedIn page</a>
* <a href="https://nebulagraph.slack.com/archives/DJQC9P0H5/p1557815158000200">Slack channel</a>
* email: info@vesoft.com
